﻿@page "/"
@page "/{Filter}"


@inject ItemServices itemServces



<div class="container-xxl">

    <div class="container mt-5">
        <table class="table table-striped shadow p-3 mb-5 bg-body rounded">
            <thead class="table-success">
                <tr>
                    <th>Id</th>
                    <th>Text</th>
                    <th>Zu erledigen bis</th>
                    <th>Status</th>
                    <th>Aktion</th>
                </tr>
            </thead>
            <tbody>
                @if (TodoItems.Any())
                {
                    @foreach (var TodoItem in TodoItems)
                    {
                <tr>
                    <td>@TodoItem.Id</td>
                    <td>@TodoItem.Text</td>
                    <td>@TodoItem.DoneBy</td>
                    <td>
                        @if (TodoItem.Done)
                        {
                            <span class="oi oi-check" style="color: #008172;"></span>
                        }
                        else
                        {
                            <span class="oi oi-x" style="color: #810000;"></span>
                        }
                    </td>
                    <td><button type="button" class="btn btn-outline-success" @onclick="(() => toggleTodoItemData(TodoItem))">Erledigen</button>
                    <button class="btn btn-outline-danger" @onclick="(() => DeleteTodoItem(TodoItem))">Löschen</button></td>
                </tr>
                    }
                }
                else
                {
                    <tr><td colspan="6"><strong>Keine Aufgaben vorhanden</strong></td></tr>
                }
            </tbody>
        </table>
    </div>

    <div class="row">
        <div class="col-5 bg-light justify-content-start shadow p-3 mb-5 bg-body rounded">

            <p class="fs-2">Neues ToDo hinzufügen</p>

            <EditForm Model="@NewTodoItem">
                <div class="form-group">
                    <label for="Text">Aufgabe</label>
                    <input type="text" id="name" class="form-control" @bind-value="@NewTodoItem.Text" />
                </div>

                <div class="form-group mt-3">
                    <label for="DoneBy">Erledigt bis</label>
                    <input type="datetime-local" @bind="@NewTodoItem.DoneBy" />

                </div>

                <div class="text-center p-3 mb-3">
                    <button class="btn btn-primary" @onclick="AddNewTodoItem">Hinzufügen</button>
                </div>
            </EditForm>
        </div>

    </div>
</div>

@code {

    //Routing-Parameter

    [Parameter]
    public String Filter { get; set; } //Property mit dem gleichen namen wie die Routingvatiable (Zeile 2) ermöglicht codezugriff




    //Variablen

    List<TodoItem> TodoItems = new List<TodoItem>();

    public TodoItem NewTodoItem { get; set; } = new TodoItem(DateTime.Now);

    TodoItem UpdateTodoItem = new TodoItem();



    //Blazor Lifecycle Funktionen

    protected override async Task OnParametersSetAsync()
    {
        await RefreshTodoItems();
    }


    protected override async Task OnInitializedAsync()
    {
        await RefreshTodoItems();
    }



    //Eine Funktionen

    private async Task RefreshTodoItems()
    {
        TodoItems = await itemServces.GetItemAsync();


        if(Filter != null)
        {
            if (String.Equals(Filter.ToLower(), "open")) //Nur offene Items anzeigen
            {

                TodoItems = TodoItems.Where(p => p.Done == false ).ToList();
            }
            else if (String.Equals(Filter.ToLower(), "next")) //Nur offene Items und nach Datum sortiert
            {
                TodoItems = TodoItems.Where(p => p.Done == false).OrderBy(p => p.DoneBy).ToList();
            }
            else if (String.Equals(Filter.ToLower(), "done")) //Nur abgeschlossene Items anzeigen
            {
                TodoItems = TodoItems.Where(p => p.Done == true).ToList();
            }

        }

    }



    private async Task AddNewTodoItem()
    {
        await itemServces.AddItemAsync(NewTodoItem);
        NewTodoItem = new TodoItem(DateTime.Now);
        await RefreshTodoItems();
    }



    private void SetTodoItemForUpdate(TodoItem TodoItem)
    {
        UpdateTodoItem = TodoItem;
    }

    private async Task UpdateTodoItemData()
    {
        await itemServces.UpdateItemAsync(UpdateTodoItem);
        await RefreshTodoItems();
    }


    private async Task toggleTodoItemData(TodoItem TodoItem)
    {
        UpdateTodoItem = TodoItem;
        UpdateTodoItem.Done = !UpdateTodoItem.Done;
        await itemServces.UpdateItemAsync(UpdateTodoItem);
        await RefreshTodoItems();
    }


    private async Task DeleteTodoItem(TodoItem TodoItem)
    {
        await itemServces.DeleteItemAsync(TodoItem);
        await RefreshTodoItems();
    }
}